package jp.ossc.installer.tools.inventory;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.ossc.installer.util.OpenStandiaXmlFile;

import org.xml.sax.SAXException;

/**
 * Cxg[fBNg[̎QƏSۂłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public abstract class AbstractCheckInventory extends AbstaractInventory {

    /**
     * G[bZ[W : OpenStandia/InstallerCXg[ĂȂꍇ<br>
     */
    protected static final String ERR_MSG_NOT_INSTALLED_OPENSTANDIA = "OpenStandia/Installer̓CXg[Ă܂B";

    /**
     * Cxg[t@CQƂ܂B<br>
     * @param productName v_Ng
     * @param stackXml X^bN`t@C
     * @throws IOException IOException
     * @throws SAXException SAXException
     * @throws ParserConfigurationException ParserConfigurationException
     * @throws TransformerException TransformerException
     * @see jp.ossc.installer.tools.inventory.AbstaractInventory#execute(java.lang.String, java.io.File)
     */
    @Override
    public void execute(final String productName, final File stackXml)
        throws IOException, ParserConfigurationException, SAXException,
        TransformerException {

        // X^bN`t@Cǂݍ
        stackXmlMap = OpenStandiaXmlFile.getStackXmlProperties(stackXml);

        // OpenStandiaz[fBNg擾
        openStandiaHomeDir = OpenStandiaXmlFile
                .getOpenStandiaHome(stackXmlMap);

        // Cxg[t@CpX擾
        final String inventoryFilePath = OpenStandiaXmlFile
                .getInventoryFilePath(openStandiaHomeDir);

        // Cxg[t@C݂邩ǂ
        inventory = (new File(inventoryFilePath)).getAbsoluteFile();
        if (inventory.exists() && inventory.isFile()) {
            // ݂ꍇ
        } else {
            // ݂Ȃꍇ
            throw new RuntimeException(ERR_MSG_NOT_INSTALLED_OPENSTANDIA);
        }

    }

}
