package jp.ossc.installer.tools.inventory;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.xml.sax.SAXException;

/**
 * Cxg[fBNg[ɂăv_NgCXg[Ă邩mFSNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class CheckProduct extends AbstractCheckInventory {

    /**
     * Cxg[t@Cv_NgR\[ɏo͂܂B<br>
     *  Ƀv_NgCXg[ĂȂꍇ́ARuntimeException𔭐܂B<br>
     * @param productName v_Ng
     * @param stackXml X^bN`t@C
     * @throws IOException IOException
     * @throws SAXException SAXException
     * @throws ParserConfigurationException ParserConfigurationException
     * @throws TransformerException TransformerException
     * @see jp.ossc.installer.tools.inventory.AbstaractCheckInventory#execute(java.lang.String, java.io.File)
     */
    @Override
    public void execute(final String productName, final File stackXml)
        throws IOException, ParserConfigurationException, SAXException,
        TransformerException {

        // ʃNXs
        try {
            super.execute(productName, stackXml);
        } catch (RuntimeException e) {
            if (e.getMessage().equals(ERR_MSG_NOT_INSTALLED_OPENSTANDIA)) {
                // Cxg[t@C݂Ȃꍇ
                System.out.println(productName + " " + NOT_INSTALLED_VALUE);
            } else {
                // Ȃ
            }
            throw e;
        }

        // w肳ꂽv_Ng̃o[W擾
        final String installedProductVer = getProductVerNode(productName);

        // Wo
        System.out.println(productName + " " + installedProductVer);

        // v_NgCXg[Ă邩ǂ
        if (installedProductVer.equals(NOT_INSTALLED_VALUE)) {
            throw new RuntimeException("w肳ꂽv_Ng̓CXg[Ă܂B");
        } else {
            // Ȃ
        }

    }

}
