package jp.ossc.installer.tools.inventory;

import java.io.File;

/**
 * Cxg[fBNg[ҏWɊւ郁CNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class EditMain {

    /**
     * [h : CXg[<br>
     */
    private static final String MODE_INSTALL = "install";

    /**
     * [h : ACXg[<br>
     */
    private static final String MODE_UNINSTALL = "uninstall";

    /**
     * [h : Abvf[g<br>
     */
    private static final String MODE_UPDATE = "update";

    /**
     * 񃁃bZ[W : m̏[h̏ꍇ<br>
     */
    private static final String INFO_MSG_UNKNOWN_MODE = "m̏[hłB : [%s]";

    /**
     * C<br>
     * @param args 
     *               [0] : v_NgNo
     *               [1] : [h(CXg[AACXg[AAbvf[g)
     *               [2] : X^bN`t@C(tpX)
     * @throws Throwable Throwable
     */
    public static void main(String[] args) throws Throwable {
        try {
            // ̎擾
            final String no = args[0];
            final String mode = args[1];
            final String stackXmlPath = args[2];

            // [hɂ菈
            final File stackXml = new File(stackXmlPath);
            if (mode == null) {
                final String msg = String.format(INFO_MSG_UNKNOWN_MODE, mode);
                throw new IllegalArgumentException(msg);
            } else if (mode.equals(MODE_INSTALL)) {
                AbstaractInventory install = new Install();
                install.execute(no, stackXml);
            } else if (mode.equals(MODE_UNINSTALL)) {
                AbstaractInventory unInstall = new UnInstall();
                unInstall.execute(no, stackXml);
            } else if (mode.equals(MODE_UPDATE)) {
                AbstaractInventory install = new Update();
                install.execute(no, stackXml);
            } else {
                final String msg = String.format(INFO_MSG_UNKNOWN_MODE, mode);
                throw new IllegalArgumentException(msg);
            }
        } catch (Throwable t) {
            throw t;
        }
    }

}
